<?php
/* -----------------------------------------------------------------------------------------
   $Id$

   modified eCommerce Shopsoftware
   http://www.modified-shop.org

   Copyright (c) 2009 - 2013 [www.modified-shop.org]
   -----------------------------------------------------------------------------------------
   Released under the GNU General Public License
   ---------------------------------------------------------------------------------------*/

chdir('../../../../../');
require_once('includes/application_top.php');

// include needed functions
require_once(DIR_FS_CATALOG.'ext/modules/payment/sofort/inc/get_external_content.inc.php');

// include needed classes
require_once(DIR_WS_CLASSES.'order.php');
require_once(DIR_FS_CATALOG.'ext/modules/payment/sofort/core/sofortLibNotification.inc.php');
require_once(DIR_FS_CATALOG.'ext/modules/payment/sofort/core/sofortLibTransactionData.inc.php');
require_once(DIR_FS_CATALOG.'ext/modules/payment/sofort/core/fileLogger.php');

// logger
$logger = new FileLogger();
$logger->setLogfilePath(DIR_FS_CATALOG.'ext/modules/payment/sofort/log/sofort_'.date('Y-m-d').'.log');
$logger->setErrorLogfilePath(DIR_FS_CATALOG.'ext/modules/payment/sofort/log/sofort_error_'.date('Y-m-d').'.log');
$logger->setWarningsLogfilePath(DIR_FS_CATALOG.'ext/modules/payment/sofort/log/sofort_warning_'.date('Y-m-d').'.log');

// get transaction
$SofortLibNotification = new SofortLibNotification();
$tID = $SofortLibNotification->getNotification(get_external_content('php://input', 3, false));

if (tep_not_null($tID)) {

  $orders_query = tep_db_query("SELECT order_id
                                  FROM sofort_sofortueberweisung
                                 WHERE transaction_id = '".tep_db_input($tID)."'");
  if (tep_db_num_rows($orders_query) == 1) {

    // transaction data
    $SofortLibTransactionData = new SofortLibTransactionData(MODULE_PAYMENT_SOFORT_SOFORTUEBERWEISUNG_KEY);

    // set Logging
    $SofortLibTransactionData->setLogger($logger);
    if (MODULE_PAYMENT_SOFORT_SOFORTUEBERWEISUNG_LOGGING == 'True') {
      $SofortLibTransactionData->setLogEnabled();
    }

    // get transaction
    $SofortLibTransactionData->addTransaction($tID);
    $SofortLibTransactionData->sendRequest();

    if ($SofortLibTransactionData->isError() === false) {

      $tID = $SofortLibTransactionData->getTransaction();
      $status = $SofortLibTransactionData->getStatus();
      $reason = $SofortLibTransactionData->getStatusReason(0,0);

      // order id
      $orders = tep_db_fetch_array($orders_query);
      $order = new order($orders['order_id']);

      include_once (DIR_FS_CATALOG . 'includes/languages/english/modules/payment/sofort_sofortueberweisung.php');

      switch ($status) {
        case 'pending':
          $order_status_id = constant('MODULE_PAYMENT_SOFORT_SOFORTUEBERWEISUNG_ORDER_STATUS_ID');
          $comments = sprintf(constant('MODULE_PAYMENT_SOFORT_SOFORTUEBERWEISUNG_SUCCESS_TRANSACTION'), $tID);
          break;
        case 'received':
          $order_status_id = constant('MODULE_PAYMENT_SOFORT_SOFORTUEBERWEISUNG_REC_STATUS_ID');
          $comments = sprintf(constant('MODULE_PAYMENT_SOFORT_SOFORTUEBERWEISUNG_SUCCESS_PAYMENT'), $tID);
          break;
        case 'refunded':
          $order_status_id = constant('MODULE_PAYMENT_SOFORT_SOFORTUEBERWEISUNG_REF_STATUS_ID');
          $comments = sprintf(constant('MODULE_PAYMENT_SOFORT_SOFORTUEBERWEISUNG_SUCCESS_REFUNDED'), $tID);
          break;
        case 'loss':
          $order_status_id = constant('MODULE_PAYMENT_SOFORT_SOFORTUEBERWEISUNG_LOSS_STATUS_ID');
          $comments = sprintf(constant('MODULE_PAYMENT_SOFORT_SOFORTUEBERWEISUNG_ERROR_PAYMENT'), $tID);
          break;
        case 'untraceable':
          $order_status_id = constant('MODULE_PAYMENT_SOFORT_SOFORTUEBERWEISUNG_UNC_STATUS_ID');
          $comments = sprintf(constant('MODULE_PAYMENT_SOFORT_SOFORTUEBERWEISUNG_ERROR_UNEXPECTED_STATUS'), $tID);
          break;
      }

      if ($order_status_id < 0) {
        $order_status_id = $order->info['orders_status_id'];
      }
      if ($reason != '') {
        $comments .= "\n".'Reason: ' . constant('TEXT_SOFORT_'.strtoupper($reason));
      }

      tep_db_query("UPDATE ".TABLE_ORDERS." SET orders_status = '".$order_status_id."' WHERE orders_id = '".(int) $orders['order_id']."'");
      $sql_data_array = array('orders_id' => (int) $orders['order_id'],
                              'orders_status_id' => $order_status_id,
                              'date_added' => 'now()',
                              'customer_notified' => '0',
                              'comments' => html_entity_decode($comments),
                              );

      tep_db_perform(TABLE_ORDERS_STATUS_HISTORY, $sql_data_array);
    }
  } else {

    // order is missing
    header("HTTP/1.0 404 Not Found");
    header("Status: 404 Not Found");    
  }
} else {  
  die('Direct access to this location is not allowed.');
}