<?php
/* -----------------------------------------------------------------------------------------
   $Id$

   modified eCommerce Shopsoftware
   http://www.modified-shop.org

   Copyright (c) 2009 - 2013 [www.modified-shop.org]
   -----------------------------------------------------------------------------------------
   Released under the GNU General Public License
   ---------------------------------------------------------------------------------------*/

include_once(DIR_FS_CATALOG.'includes/languages/'.$_SESSION['language'].'/modules/payment/sofort_sofortueberweisung.php');

class SofortLibPayment {

  function __construct() {}


	function SofortPayment() {
		global $order, $PHP_SELF;

    if (basename($PHP_SELF) == 'modules.php') {
      define('RUN_MODE_ADMIN', true);
    }

		$this->code = get_class($this);
		$this->version = $this->get_version();
		$this->title = constant('MODULE_PAYMENT_'.strtoupper($this->code).'_TEXT_TITLE');
		$this->description = constant('MODULE_PAYMENT_'.strtoupper($this->code).'_TEXT_DESCRIPTION');
		$this->sort_order = ((defined('MODULE_PAYMENT_'.strtoupper($this->code).'_SORT_ORDER')) ? constant('MODULE_PAYMENT_'.strtoupper($this->code).'_SORT_ORDER') : 0);
		$this->enabled = ((defined('MODULE_PAYMENT_'.strtoupper($this->code).'_STATUS') && constant('MODULE_PAYMENT_'.strtoupper($this->code).'_STATUS') == 'True') ? true : false);
		$this->info = constant('MODULE_PAYMENT_'.strtoupper($this->code).'_TEXT_INFO');
    $this->logging = ((defined('MODULE_PAYMENT_'.strtoupper($this->code).'_LOGGING') && constant('MODULE_PAYMENT_'.strtoupper($this->code).'_LOGGING') == 'True') ? true : false);
    $this->order_status = ((defined('MODULE_PAYMENT_'.strtoupper($this->code).'_TMP_STATUS_ID')) ? constant('MODULE_PAYMENT_'.strtoupper($this->code).'_TMP_STATUS_ID') : DEFAULT_ORDERS_STATUS_ID);

		$this->ks_status = false;
		if(defined('MODULE_PAYMENT_'.strtoupper($this->code).'_KS_STATUS') && constant('MODULE_PAYMENT_'.strtoupper($this->code).'_KS_STATUS') == 'True') {
			$this->title = constant('MODULE_PAYMENT_'.strtoupper($this->code).'_KS_TEXT_TITLE');
			$this->ks_status = true;
		}
    
		if (!defined('RUN_MODE_ADMIN') && is_object($order)) {
			$this->update_status();
    }

    if (defined('RUN_MODE_ADMIN') && $this->enabled === true) {
      $this->description .= constant('MODULE_PAYMENT_'.strtoupper($this->code).'_DESCRIPTION_INSTALL').'<div style="text-align:center;padding:10px 0;">'.tep_draw_button(constant('MODULE_PAYMENT_'.strtoupper($this->code).'_STATUS_INSTALL'), 'plus', tep_href_link(FILENAME_MODULES, 'set=payment&module=' . $this->code . '&moduleaction=status')).'</div>';
	    if (isset($_GET['moduleaction']) && $_GET['moduleaction'] == 'status') {
	      $this->status_install();
	    }
	  }
	}


	function update_status() {
		global $order;

		if (($this->enabled == true) && ((int) constant('MODULE_PAYMENT_'.strtoupper($this->code).'_ZONE') > 0)) {
			$check_flag = false;
			$check_query = tep_db_query("SELECT zone_id
			                               FROM " . TABLE_ZONES_TO_GEO_ZONES . "
			                              WHERE geo_zone_id = '" . constant('MODULE_PAYMENT_'.strtoupper($this->code).'_ZONE') . "'
			                                AND zone_country_id = '" . $order->billing['country']['id'] . "'
			                           ORDER BY zone_id");
			while ($check = tep_db_fetch_array($check_query)) {
				if ($check['zone_id'] < 1) {
					$check_flag = true;
					break;
				} elseif ($check['zone_id'] == $order->billing['zone_id']) {
					$check_flag = true;
					break;
				}
			}
			if ($check_flag == false) {
				$this->enabled = false;
			}
		}
		
		if (($this->enabled == true) && (constant('MODULE_PAYMENT_'.strtoupper($this->code).'_ALLOWED') != '')) {
		  $unallowed_zones = explode(',', constant('MODULE_PAYMENT_'.strtoupper($this->code).'_ALLOWED'));
		  
		  if (!in_array($order->delivery['country']['iso_code_2'], $unallowed_zones)) {
		    $this->enabled = false;
		  }
		}
	}


	function javascript_validation() {
		return false;
	}


	function selection() {
		unset($_SESSION['sofort'][$this->code]);

		$description = '';
		switch (constant('MODULE_PAYMENT_'.strtoupper($this->code).'_IMAGE')) {
			case 'Logo & Text':
				if ($this->ks_status === true) {
					$description = $this->_setImageText('logo_155x50.png', constant('MODULE_PAYMENT_'.strtoupper($this->code).'_KS_TEXT_DESCRIPTION_CHECKOUT_PAYMENT_TEXT'));
				} else {
					$description = $this->_setImageText('logo_155x50.png', constant('MODULE_PAYMENT_'.strtoupper($this->code).'_TEXT_DESCRIPTION_CHECKOUT_PAYMENT_TEXT'));
				}
				break;
			case 'Infographic':
				if ($this->ks_status === true) {
					$description = $this->_setImageText('banner_400x100_ks.png');
				} else {
					$description = $this->_setImageText('banner_300x100.png');
				}
				break;
		}

    return array('id' => $this->code, 
                 'module' => $this->title, 
                 'fields' => array(array('title' => '', 'field' => $description)));    
	}


	function pre_confirmation_check() {
		return false;
	}


	function confirmation() {
    unset($_SESSION['sofort'][$this->code]);

		return false;
	}


	function process_button() {
		return false;
	}


	function before_process() {
	  if (!isset($_SESSION['sofort'][$this->code]['tID'])) {
	    $this->_payment_action();
	  }
		return false;
	}


	function check() {
		if (!isset($this->_check)) {
			$check_query = tep_db_query("SELECT configuration_value
			                               FROM " . TABLE_CONFIGURATION . "
			                              WHERE configuration_key = 'MODULE_PAYMENT_".strtoupper($this->code)."_STATUS'");
			$this->_check = tep_db_num_rows($check_query);
		}
		return $this->_check;
	}


	function get_error() {
		$error = false;
		if (isset($_GET['payment_error']) && $_GET['payment_error'] != '') {
			$error = array('title' => constant('MODULE_PAYMENT_'.strtoupper($this->code).'_TEXT_ERROR_HEADING'),
			               'error' => html_entity_decode(constant('MODULE_PAYMENT_'.strtoupper($this->code).'_TEXT_ERROR_MESSAGE'))
			               );
		}
		return $error;
	}


	function after_process() {
	  global $insert_id;

	  // set orders status
    $order_status_id = constant('MODULE_PAYMENT_'.strtoupper($this->code).'_TMP_STATUS_ID');
    if ($order_status_id < 0) {
      $order_status_id = $this->_get_orders_status($insert_id);
    }
    $this->update_sofort_status($insert_id, $order_status_id);

	  unset($_SESSION['sofort'][$this->code]);

	  $this->after_process_callback();
	}


  function after_process_callback() {
    if (isset($_GET['nonexistorder']) && $_GET['nonexistorder'] == 'true') {
      // sending 404 to trigger new callback
      header("HTTP/1.0 404 Not Found");
      header("Status: 404 Not Found");
      exit();
    }
  }


  function _payment_data() {
    global $order, $insert_id;

    // gateway
    $this->data['success_url'] = ((ENABLE_SSL == true) ? HTTPS_SERVER : HTTP_SERVER).DIR_WS_CATALOG.FILENAME_CHECKOUT_PROCESS.'?'.tep_session_name().'='.tep_session_id();
    $this->data['abort_url'] = ((ENABLE_SSL == true) ? HTTPS_SERVER : HTTP_SERVER).DIR_WS_CATALOG.FILENAME_CHECKOUT_PAYMENT.'?'.tep_session_name().'='.tep_session_id().'&payment_error='.$this->code;
    $this->data['timeout_url'] = ((ENABLE_SSL == true) ? HTTPS_SERVER : HTTP_SERVER).DIR_WS_CATALOG.FILENAME_CHECKOUT_PAYMENT.'?'.tep_session_name().'='.tep_session_id().'&payment_error='.$this->code;
    $this->data['callback_url'] = ((ENABLE_SSL == true) ? HTTPS_SERVER : HTTP_SERVER).DIR_WS_CATALOG.'ext/modules/payment/sofort/callback/'.$this->code.'.php';
    $this->data['currency'] = $_SESSION['currency'];

    // amount
    $amount = tep_round($order->info['total'] * $order->info['currency_value'], 2);
    $this->data['amount'] = number_format($amount, 2, '.', '');

    // reason 1
    $this->data['reason_1'] = str_replace(array('{{transaction_id}}',
                                                '{{customer_id}}',
                                                '{{order_date}}',
                                                '{{customer_name}}',
                                                '{{customer_company}}',
                                                '{{customer_email}}'
                                          ),
                                          array('-TRANSACTION-',
                                                $_SESSION['customer_id'],
                                                strftime(DATE_FORMAT_SHORT),
                                                $order->customer['firstname'] . ' ' . $order->customer['lastname'],
                                                $order->customer['company'],
                                                $order->customer['email_address']
                                          ),
                                          constant('MODULE_PAYMENT_'.strtoupper($this->code).'_REASON_1'));

    // reason 2
    $this->data['reason_2'] = str_replace(array('{{transaction_id}}',
                                                '{{customer_id}}',
                                                '{{order_date}}',
                                                '{{customer_name}}',
                                                '{{customer_company}}',
                                                '{{customer_email}}'
                                          ),
                                          array('-TRANSACTION-',
                                                $_SESSION['customer_id'],
                                                strftime(DATE_FORMAT_SHORT),
                                                $order->customer['firstname'] . ' ' . $order->customer['lastname'],
                                                $order->customer['company'],
                                                $order->customer['email_address']
                                          ),
                                          constant('MODULE_PAYMENT_'.strtoupper($this->code).'_REASON_2'));
  
  }


	function _setImageText($image, $text='') {
    $languages_query = tep_db_query("SELECT code FROM ".TABLE_LANGUAGES." WHERE languages_id = '".$_SESSION['languages_id']."'");
    $languages = tep_db_fetch_array($languages_query);
    
	  switch ($languages['code']) {
	    case 'de':
	      $code = 'de';
	      $lang = 'ger';
	      break;
	    default:
	      $code = 'en';
	      $lang = 'eng';
	      break;
	  }
	  
		$image = 'https://images.sofort.com/'.$code.'/su/'.$image;
		$image = tep_image($image, constant('MODULE_PAYMENT_'.strtoupper($this->code).'_TEXT_DESCRIPTION_CHECKOUT_PAYMENT_IMAGEALT'));
		$description = constant('MODULE_PAYMENT_'.strtoupper($this->code).'_TEXT_DESCRIPTION_CHECKOUT_PAYMENT_IMAGE');
		$description = str_replace('{{code}}', $code, $description);
		$description = str_replace('{{image}}', $image, $description);
		$description = str_replace('{{text}}', $text, $description);

		//add ks-link, if ks is active
		$description = str_replace('[[link_beginn]]', '<a onclick="javascript:window.open(\'https://www.sofort-bank.com/'.$lang.'-'.strtoupper($code).'/general/kaeuferschutz/informationen-fuer-kaeufer\',\'Information\',\'toolbar=no, location=no, directories=no, status=no, menubar=no, scrollbars=yes, resizable=yes, width=1020, height=900\');" style="text-decoration:underline;">', $description);
		$description = str_replace('[[link_end]]', '</a>', $description);

		return $description;
	}


  function _get_orders_status($order_id) {
    $order_status_query = tep_db_query("SELECT orders_status FROM ".TABLE_ORDERS." WHERE orders_id = '".(int) $order_id."'");
    $order_status = tep_db_fetch_array($order_status_query);
    return $order_status['orders_status'];
  }


  function get_version() {
    if (!isset($this->_version)) {
      $this->_version = 'osCommerce_4.0';
    }
    
    return $this->_version;
  }


  public function update_sofort_status($orders_id, $order_status_id, $comments = '', $status_update = false) {
    tep_db_query("UPDATE ".TABLE_ORDERS." SET orders_status = '".$order_status_id."' WHERE orders_id = '".(int) $orders_id."'");

    $sql_data_array = array('orders_id' => (int) $orders_id,
                            'orders_status_id' => $order_status_id,
                            'date_added' => 'now()',
                            'customer_notified' => '0',
                            'comments' => html_entity_decode($comments),
                            );
    tep_db_perform(TABLE_ORDERS_STATUS_HISTORY, $sql_data_array);

    $sql_data_array = array('transaction_id' => $_SESSION['sofort'][$this->code]['tID'],
                            'order_id' => $orders_id
                            );
    tep_db_perform($this->code, $sql_data_array);
  }


  function status_install() {
    if ($this->enabled === true) {
      $stati = array('SOFORT_INST_ORDER_STATUS_TMP_NAME' => 'MODULE_PAYMENT_'.strtoupper($this->code).'_TMP_STATUS_ID',
                     'SOFORT_INST_ORDER_STATUS_UNC_NAME' => 'MODULE_PAYMENT_'.strtoupper($this->code).'_UNC_STATUS_ID',
                     'SOFORT_INST_ORDER_STATUS_ORDER_NAME' => 'MODULE_PAYMENT_'.strtoupper($this->code).'_ORDER_STATUS_ID',
                     'SOFORT_INST_ORDER_STATUS_REC_NAME' => '',
                     'SOFORT_INST_ORDER_STATUS_REF_NAME' => '',
                     'SOFORT_INST_ORDER_STATUS_LOSS_NAME' => '',
                     );
      foreach($stati as $statusname => $statusid) {

        $languages_query = tep_db_query("SELECT * FROM " . TABLE_LANGUAGES . " ORDER BY sort_order");
        while ($languages = tep_db_fetch_array($languages_query)) {
          if (is_file(DIR_FS_CATALOG.'includes/languages/'.$languages['directory'].'/modules/payment/sofort_payment.php')) {
            include(DIR_FS_CATALOG.'includes/languages/'.$languages['directory'].'/modules/payment/sofort_payment.php');
          }
          if (${$statusname} != '') {
            $check_query = tep_db_query("SELECT orders_status_id
                                           FROM " . TABLE_ORDERS_STATUS . "
                                          WHERE orders_status_name = '" .${$statusname}. "'
                                            AND language_id = '".$languages['languages_id']."'
                                          LIMIT 1");
            $status = tep_db_fetch_array($check_query);
            if(tep_db_num_rows($check_query) < 1 || (${$statusid} && $status['orders_status_id'] != ${$statusid})) {
              if (!${$statusid}) {
                $status_query = tep_db_query("SELECT max(orders_status_id) as status_id FROM " . TABLE_ORDERS_STATUS);
                $status = tep_db_fetch_array($status_query);
                ${$statusid} = $status['status_id']+1;
              }
              $check_query = tep_db_query("SELECT orders_status_id
                                             FROM " . TABLE_ORDERS_STATUS . "
                                            WHERE orders_status_id = '".${$statusid} ."'
                                              AND language_id='".$languages['languages_id']."'");
              if(tep_db_num_rows($check_query)<1) {
                // insert status
                $sql_data_array = array('orders_status_name' => ${$statusname},
                                        'orders_status_id' => ${$statusid},
                                        'language_id' => $languages['languages_id']
                                        );
                tep_db_perform(TABLE_ORDERS_STATUS, $sql_data_array);

                // update status
                if ($statusid != '') {
                  tep_db_query("UPDATE " . TABLE_CONFIGURATION . "
                                   SET configuration_value = '" . ${$statusid} . "',
                                       last_modified = NOW()
                                 WHERE configuration_key = '" . $statusid . "'");
                }
              }
            } else {
              ${$statusid} = $status['orders_status_id'];

              // update status
               if ($statusid != '') {
                tep_db_query("UPDATE " . TABLE_CONFIGURATION . "
                                 SET configuration_value = '" . ${$statusid} . "',
                                     last_modified = NOW()
                               WHERE configuration_key = '" . $statusid . "'");
              }
            }
          }
        }
      }
    }
  }


	function install_default() {
    tep_db_query("INSERT INTO " . TABLE_CONFIGURATION . " ( configuration_key, configuration_value, configuration_group_id, sort_order, configuration_title, configuration_description, set_function, date_added) values ('MODULE_PAYMENT_".strtoupper($this->code)."_STATUS', 'True', '6', '3', '".constant('MODULE_PAYMENT_'.strtoupper($this->code).'_STATUS_TITLE')."', '".constant('MODULE_PAYMENT_'.strtoupper($this->code).'_STATUS_DESC')."', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");
    tep_db_query("INSERT INTO " . TABLE_CONFIGURATION . " ( configuration_key, configuration_value, configuration_group_id, sort_order, configuration_title, configuration_description, set_function, date_added) values ('MODULE_PAYMENT_".strtoupper($this->code)."_LOGGING', 'False', '6', '3', '".constant('MODULE_PAYMENT_'.strtoupper($this->code).'_LOGGING_TITLE')."', '".constant('MODULE_PAYMENT_'.strtoupper($this->code).'_LOGGING_DESC')."', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");
    tep_db_query("INSERT INTO " . TABLE_CONFIGURATION . " ( configuration_key, configuration_value, configuration_group_id, sort_order, configuration_title, configuration_description, date_added) values ('MODULE_PAYMENT_".strtoupper($this->code)."_ALLOWED', '', '6', '0', '".constant('MODULE_PAYMENT_'.strtoupper($this->code).'_ALLOWED_TITLE')."', '".constant('MODULE_PAYMENT_'.strtoupper($this->code).'_ALLOWED_DESC')."', now())");
    tep_db_query("INSERT INTO " . TABLE_CONFIGURATION . " ( configuration_key, configuration_value, configuration_group_id, sort_order, configuration_title, configuration_description, date_added) values ('MODULE_PAYMENT_".strtoupper($this->code)."_SORT_ORDER', '1', '6', '20', '".constant('MODULE_PAYMENT_'.strtoupper($this->code).'_SORT_ORDER_TITLE')."', '".constant('MODULE_PAYMENT_'.strtoupper($this->code).'_SORT_ORDER_DESC')."', now())");
    tep_db_query("INSERT INTO " . TABLE_CONFIGURATION . " ( configuration_key, configuration_value, configuration_group_id, sort_order, configuration_title, configuration_description, use_function, set_function, date_added) values ('MODULE_PAYMENT_".strtoupper($this->code)."_ZONE', '0', '6', '2', '".constant('MODULE_PAYMENT_'.strtoupper($this->code).'_ZONE_TITLE')."', '".constant('MODULE_PAYMENT_'.strtoupper($this->code).'_ZONE_DESC')."', 'tep_get_zone_class_title', 'tep_cfg_pull_down_zone_classes(', now())");
    tep_db_query("INSERT INTO " . TABLE_CONFIGURATION . " ( configuration_key, configuration_value, configuration_group_id, sort_order, configuration_title, configuration_description, set_function, use_function, date_added) values ('MODULE_PAYMENT_".strtoupper($this->code)."_ORDER_STATUS_ID', '".DEFAULT_ORDERS_STATUS_ID."',  '6', '10', '".constant('MODULE_PAYMENT_'.strtoupper($this->code).'_ORDER_STATUS_ID_TITLE')."', '".constant('MODULE_PAYMENT_'.strtoupper($this->code).'_ORDER_STATUS_ID_DESC')."', 'tep_cfg_pull_down_order_statuses_sofort(', 'tep_get_order_status_name', now())");
    tep_db_query("INSERT INTO " . TABLE_CONFIGURATION . " ( configuration_key, configuration_value, configuration_group_id, sort_order, configuration_title, configuration_description, set_function, use_function, date_added) values ('MODULE_PAYMENT_".strtoupper($this->code)."_TMP_STATUS_ID', '".DEFAULT_ORDERS_STATUS_ID."',  '6', '8', '".constant('MODULE_PAYMENT_'.strtoupper($this->code).'_TMP_STATUS_ID_TITLE')."', '".constant('MODULE_PAYMENT_'.strtoupper($this->code).'_TMP_STATUS_ID_DESC')."', 'tep_cfg_pull_down_order_statuses_sofort(', 'tep_get_order_status_name', now())");
    tep_db_query("INSERT INTO " . TABLE_CONFIGURATION . " ( configuration_key, configuration_value, configuration_group_id, sort_order, configuration_title, configuration_description, set_function, use_function, date_added) values ('MODULE_PAYMENT_".strtoupper($this->code)."_UNC_STATUS_ID', '".DEFAULT_ORDERS_STATUS_ID."',  '6', '9', '".constant('MODULE_PAYMENT_'.strtoupper($this->code).'_UNC_STATUS_ID_TITLE')."', '".constant('MODULE_PAYMENT_'.strtoupper($this->code).'_UNC_STATUS_ID_DESC')."', 'tep_cfg_pull_down_order_statuses_sofort(', 'tep_get_order_status_name', now())");
    tep_db_query("INSERT INTO " . TABLE_CONFIGURATION . " ( configuration_key, configuration_value, configuration_group_id, sort_order, configuration_title, configuration_description, set_function, use_function, date_added) values ('MODULE_PAYMENT_".strtoupper($this->code)."_REC_STATUS_ID', '0',  '6', '11', '".constant('MODULE_PAYMENT_'.strtoupper($this->code).'_REC_STATUS_ID_TITLE')."', '".constant('MODULE_PAYMENT_'.strtoupper($this->code).'_REC_STATUS_ID_DESC')."', 'tep_cfg_pull_down_order_statuses_sofort(', 'tep_get_order_status_name', now())");
    tep_db_query("INSERT INTO " . TABLE_CONFIGURATION . " ( configuration_key, configuration_value, configuration_group_id, sort_order, configuration_title, configuration_description, set_function, use_function, date_added) values ('MODULE_PAYMENT_".strtoupper($this->code)."_REF_STATUS_ID', '0',  '6', '11', '".constant('MODULE_PAYMENT_'.strtoupper($this->code).'_REF_STATUS_ID_TITLE')."', '".constant('MODULE_PAYMENT_'.strtoupper($this->code).'_REF_STATUS_ID_DESC')."', 'tep_cfg_pull_down_order_statuses_sofort(', 'tep_get_order_status_name', now())");
    tep_db_query("INSERT INTO " . TABLE_CONFIGURATION . " ( configuration_key, configuration_value, configuration_group_id, sort_order, configuration_title, configuration_description, set_function, use_function, date_added) values ('MODULE_PAYMENT_".strtoupper($this->code)."_LOSS_STATUS_ID', '0',  '6', '12', '".constant('MODULE_PAYMENT_'.strtoupper($this->code).'_LOSS_STATUS_ID_TITLE')."', '".constant('MODULE_PAYMENT_'.strtoupper($this->code).'_LOSS_STATUS_ID_DESC')."', 'tep_cfg_pull_down_order_statuses_sofort(', 'tep_get_order_status_name', now())");
    tep_db_query("INSERT INTO " . TABLE_CONFIGURATION . " ( configuration_key, configuration_value, configuration_group_id, sort_order, configuration_title, configuration_description, date_added) values ('MODULE_PAYMENT_".strtoupper($this->code)."_REASON_1', '" . tep_db_input(STORE_NAME) . "',  '6', '4', '".constant('MODULE_PAYMENT_'.strtoupper($this->code).'_REASON_1_TITLE')."', '".constant('MODULE_PAYMENT_'.strtoupper($this->code).'_REASON_1_DESC')."', now())");
    tep_db_query("INSERT INTO " . TABLE_CONFIGURATION . " ( configuration_key, configuration_value, configuration_group_id, sort_order, configuration_title, configuration_description, date_added) values ('MODULE_PAYMENT_".strtoupper($this->code)."_REASON_2', '{{transaction_id}}', '6', '4', '".constant('MODULE_PAYMENT_'.strtoupper($this->code).'_REASON_2_TITLE')."', '".constant('MODULE_PAYMENT_'.strtoupper($this->code).'_REASON_2_DESC')."', now())");
    tep_db_query("INSERT INTO " . TABLE_CONFIGURATION . " ( configuration_key, configuration_value, configuration_group_id, sort_order, configuration_title, configuration_description, set_function, date_added) values ('MODULE_PAYMENT_".strtoupper($this->code)."_IMAGE', 'Infographic',  '6', '6', '".constant('MODULE_PAYMENT_'.strtoupper($this->code).'_IMAGE_TITLE')."', '".constant('MODULE_PAYMENT_'.strtoupper($this->code).'_IMAGE_DESC')."', 'tep_cfg_select_option(array(\'Infographic\',\'Logo & Text\'), ', now())");

	  tep_db_query("CREATE TABLE IF NOT EXISTS `".$this->code."` (
                  `transaction_id` VARCHAR( 128 ) NOT NULL ,
                  `order_id` INT( 11 ) NOT NULL ,
                  INDEX ( `transaction_id` )
                  )");
	}


	function keys_default() {
		return array(0  => 'MODULE_PAYMENT_'.strtoupper($this->code).'_STATUS' ,
                 11 => 'MODULE_PAYMENT_'.strtoupper($this->code).'_ALLOWED' ,
                 12 => 'MODULE_PAYMENT_'.strtoupper($this->code).'_ZONE' ,
                 13 => 'MODULE_PAYMENT_'.strtoupper($this->code).'_REASON_1',
                 14 => 'MODULE_PAYMENT_'.strtoupper($this->code).'_REASON_2' ,
                 15 => 'MODULE_PAYMENT_'.strtoupper($this->code).'_IMAGE' ,
                 16 => 'MODULE_PAYMENT_'.strtoupper($this->code).'_TMP_STATUS_ID' ,
                 17 => 'MODULE_PAYMENT_'.strtoupper($this->code).'_UNC_STATUS_ID' ,
                 18 => 'MODULE_PAYMENT_'.strtoupper($this->code).'_ORDER_STATUS_ID' ,
                 19 => 'MODULE_PAYMENT_'.strtoupper($this->code).'_REC_STATUS_ID',
                 20 => 'MODULE_PAYMENT_'.strtoupper($this->code).'_REF_STATUS_ID',
                 21 => 'MODULE_PAYMENT_'.strtoupper($this->code).'_LOSS_STATUS_ID',
                 22 => 'MODULE_PAYMENT_'.strtoupper($this->code).'_SORT_ORDER',
                 23 => 'MODULE_PAYMENT_'.strtoupper($this->code).'_LOGGING',
                 );
	}

}


/**
 * tep_cfg_pull_down_order_statuses_sofort()
 *
 * @param mixed $order_status_id
 * @param string $key
 * @return
 */
if (!function_exists('tep_cfg_pull_down_order_statuses_sofort')) {
  function tep_cfg_pull_down_order_statuses_sofort($order_status_id, $key = '') {
    $name = (($key) ? 'configuration['.$key.']' : 'configuration_value');
    $statuses_array = array (array ('id' => '-1', 'text' => TEXT_NO_STATUSUPDATE));
    $statuses_array[] = array ('id' => '1', 'text' => TEXT_DEFAULT);
    $statuses_query = tep_db_query("SELECT orders_status_id,
                                           orders_status_name
                                      FROM ".TABLE_ORDERS_STATUS."
                                     WHERE language_id = '".(int)$_SESSION['languages_id']."'
                                  ORDER BY orders_status_name");
    while ($statuses = tep_db_fetch_array($statuses_query)) {
      $statuses_array[] = array ('id' => $statuses['orders_status_id'], 'text' => $statuses['orders_status_name']);
    }
    return tep_draw_pull_down_menu($name, $statuses_array, $order_status_id);
  }
}
?>