<?php
/* -----------------------------------------------------------------------------------------
   $Id$

   modified eCommerce Shopsoftware
   http://www.modified-shop.org

   Copyright (c) 2009 - 2013 [www.modified-shop.org]
   -----------------------------------------------------------------------------------------
   Released under the GNU General Public License
   ---------------------------------------------------------------------------------------*/

// include needed classes
require_once(DIR_FS_CATALOG.'ext/modules/payment/sofort/classes/sofortLibSofortueberweisungGateway.inc.php');
require_once(DIR_FS_CATALOG.'ext/modules/payment/sofort/classes/SofortLibPayment.php');
require_once(DIR_FS_CATALOG.'ext/modules/payment/sofort/core/fileLogger.php');

class sofort_sofortueberweisung extends SofortLibPayment {

	var $code, $title, $description, $enabled;

  function __construct() {
    $this->SofortPayment();

      // logger
    $this->logger = new FileLogger();
    $this->logger->setLogfilePath(DIR_FS_CATALOG.'ext/modules/payment/sofort/log/sofort_'.date('Y-m-d').'.log');
    $this->logger->setErrorLogfilePath(DIR_FS_CATALOG.'ext/modules/payment/sofort/log/sofort_error_'.date('Y-m-d').'.log');
    $this->logger->setWarningsLogfilePath(DIR_FS_CATALOG.'ext/modules/payment/sofort/log/sofort_warning_'.date('Y-m-d').'.log');
	}


  function _payment_action () {
    global $order, $xtPrice, $insert_id;

    $this->_payment_data();

    // prepare call
    $this->Sofortueberweisung = new sofortLibSofortueberweisungGateway(constant('MODULE_PAYMENT_'.strtoupper($this->code).'_KEY'));

    // set Logging
    $this->Sofortueberweisung->setLogger($this->logger);
    if ($this->logging === true) {
      $this->Sofortueberweisung->setLogEnabled();
    }

    $this->Sofortueberweisung->setAmount($this->data['amount']);
    $this->Sofortueberweisung->setCurrencyCode($this->data['currency']);
    $this->Sofortueberweisung->setReason($this->data['reason_1'], $this->data['reason_2']);
    $this->Sofortueberweisung->setSuccessUrl($this->data['success_url'], true);
    $this->Sofortueberweisung->setUserVariable(array('0' => $this->data['success_url']));
    $this->Sofortueberweisung->setAbortUrl($this->data['abort_url']);
    $this->Sofortueberweisung->setTimeoutUrl($this->data['timeout_url']);
    $this->Sofortueberweisung->setNotificationUrl($this->data['callback_url']);
    $this->Sofortueberweisung->setCustomerprotection($this->ks_status);
    $this->Sofortueberweisung->setVersion($this->version);
    $this->Sofortueberweisung->setSuccessLinkRedirect(true);
    //$this->Sofortueberweisung->setTimeout(SESSION_LIFE_CUSTOMERS-(60*5));

    // send request
    $this->Sofortueberweisung->sendRequest();

    // write some variables to session
    $_SESSION['sofort'][$this->code]['total'] = $this->data['amount'];
    $_SESSION['sofort'][$this->code]['oID'] = $insert_id;
    $_SESSION['sofort'][$this->code]['tID'] = $this->Sofortueberweisung->getTransactionId();
        
    if ($this->Sofortueberweisung->isError()) {
      // trigger error
      $this->Sofortueberweisung->setError($this->Sofortueberweisung->isError());

      // redirect
      tep_redirect(tep_href_link(FILENAME_CHECKOUT_PAYMENT, 'payment_error='.$this->code, 'SSL'));
    } else {

      // redirected to $paymentUrl
      tep_redirect($this->Sofortueberweisung->getPaymentUrl());
    }
  }


	function install () {
	  $this->install_default();
    tep_db_query("INSERT INTO " . TABLE_CONFIGURATION . " ( configuration_key, configuration_value, configuration_group_id, sort_order, configuration_title, configuration_description, set_function, date_added) values ('MODULE_PAYMENT_".strtoupper($this->code)."_KS_STATUS', 'False', '6', '3', '".constant('MODULE_PAYMENT_'.strtoupper($this->code).'_KS_STATUS_TITLE')."', '".constant('MODULE_PAYMENT_'.strtoupper($this->code).'_KS_STATUS_DESC')."', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");
    tep_db_query("INSERT INTO " . TABLE_CONFIGURATION . " ( configuration_key, configuration_value, configuration_group_id, sort_order, configuration_title, configuration_description, date_added) values ('MODULE_PAYMENT_".strtoupper($this->code)."_KEY', '',  '6', '4', '".constant('MODULE_PAYMENT_'.strtoupper($this->code).'_KEY_TITLE')."', '".constant('MODULE_PAYMENT_'.strtoupper($this->code).'_KEY_DESC')."', now())");
	}


	function remove () {
		tep_db_query("DELETE FROM " . TABLE_CONFIGURATION . " WHERE configuration_key IN ('" . implode("', '", $this->keys()) . "')");
	  tep_db_query("DROP TABLE `".$this->code."`");
	}


	function keys () {
	  $keys = $this->keys_default();
	  $keys[1] = 'MODULE_PAYMENT_'.strtoupper($this->code).'_KS_STATUS';
	  $keys[2] = 'MODULE_PAYMENT_'.strtoupper($this->code).'_KEY';

    ksort($keys);
    $keys = array_values($keys);

		return $keys;
	}

}
?>